local room = require("room")
local edge = require("edge")
local sundial = require("obj/sundial")
local keypad = require("obj/keypad")
local door = require("obj/door")

local m = room:new()

sundial:from{
    numbers = {3, 5, 8, 2, 7},
}:install(m, 140, 160)

local d = door:from{
    destination = 'vivarium',
}

d:install(m, 80, 60)
d.mousepressed = d.keypadMode

keypad:from{
    code = 35827,
    oncorrect = function (self)
        d.locked = false
    end,
}:install(m, 180, 100)

edge.set(m, 'up', "alley")

return m
